<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import ${pub.getPKGCodeName()}.core.util.annotation.DEField;
import ${pub.getPKGCodeName()}.core.util.annotation.DEPredefinedField;
import ${pub.getPKGCodeName()}.core.util.enums.DEPredefinedFieldFillMode;
import ${pub.getPKGCodeName()}.core.util.enums.DEPredefinedFieldType;
import java.io.Serializable;

/**
 * 实体[${item.getLogicName()}]
 */
public class ${item.getCodeName()} implements Serializable {

	private static final long serialVersionUID = 1L;

<#--  实体属性相关  -->
<#if item.getPSDEFields()??>
    <#list item.getPSDEFields() as defield>
    /**
     * ${defield.getLogicName()}
     */
    <#comment>主键</#comment>
    <#if defield.isKeyDEField()==true>
    @DEField(isKeyField=true)
    </#if>
    <#comment>属性默认值</#comment>
    <#if defield.getDefaultValue()?? && defield.getDefaultValue()!=''>
    <#-- @DEField(defaultValue = "${defield.getDefaultValue()}") -->
    </#if>
    <#comment>系统预置属性</#comment>
    <#if  defield.getPredefinedType?? && defield.getPredefinedType()??>
        <#comment>系统预置属性</#comment>
        <#if defield.getPredefinedType()?lower_case =='createman' >
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.CREATEMAN)
        <#elseif defield.getPredefinedType()?lower_case =='createmanname'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.CREATEMANNAME)
        <#elseif defield.getPredefinedType()?lower_case =='updateman'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT_UPDATE,preType = DEPredefinedFieldType.UPDATEMAN)
        <#elseif defield.getPredefinedType()?lower_case =='updatemanname'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT_UPDATE,preType = DEPredefinedFieldType.UPDATEMANNAME)
        <#elseif defield.getPredefinedType()?lower_case =='createdate'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.CREATEDATE)
        <#elseif defield.getPredefinedType()?lower_case =='updatedate'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT_UPDATE,preType = DEPredefinedFieldType.UPDATEDATE)
        <#elseif defield.getPredefinedType()?lower_case =='orgid'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.ORGID)
        <#elseif defield.getPredefinedType()?lower_case =='orgname'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.ORGNAME)
        <#elseif defield.getPredefinedType()?lower_case =='orgsectorid'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.ORGSECTORID)
        <#elseif defield.getPredefinedType()?lower_case =='orgsectorname'>
    @DEPredefinedField(fill= DEPredefinedFieldFillMode.INSERT,preType = DEPredefinedFieldType.ORGSECTORNAME)
        </#if>
    </#if>
    <#assign defDataType = (defield.getDataType())!"">
    <#if defDataType == "DATETIME" || (defDataType=='PICKUPDATA' && srfdatatype(defield.getStdDataType())== "DATETIME" && defield.getValueFormat()=="%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "DATE" || (defDataType=='PICKUPDATA' && srfdatatype(defield.getStdDataType())== "DATETIME" && defield.getValueFormat()=="%1$tY-%1$tm-%1$td")>
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "TIME" || (defDataType=='PICKUPDATA' && srfdatatype(defield.getStdDataType())== "DATETIME" && defield.getValueFormat()=="%1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="HH:mm", locale = "zh" , timezone="GMT+8")
    </#if>
    private ${srfjavatype(defield.getStdDataType())} ${defield.getCodeName()?uncap_first};

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean ${defield.getCodeName()?uncap_first}DirtyFlag;

    </#list>

    <#list item.getPSDEFields() as defield>
    /**
     * 获取 [${defield.getLogicName()}]
     */
    @JsonProperty("${defield.getCodeName()?lower_case}")
    @JSONField(name="${defield.getCodeName()?lower_case}")
    public ${srfjavatype(defield.getStdDataType())} get${defield.getCodeName()?cap_first}(){
        return this.${defield.getCodeName()?uncap_first} ;
    }

    /**
     * 设置 [${defield.getLogicName()}]
     */
    @JsonProperty("${defield.getCodeName()?lower_case}")
    @JSONField(name="${defield.getCodeName()?lower_case}")
    public void set${defield.getCodeName()?cap_first}(${srfjavatype(defield.getStdDataType())} ${defield.getCodeName()?uncap_first}){
        this.${defield.getCodeName()?uncap_first} = ${defield.getCodeName()?uncap_first} ;
        this.${defield.getCodeName()?uncap_first}DirtyFlag = true ;
    }

    /**
     * 获取 [${defield.getLogicName()}]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean get${defield.getCodeName()?cap_first}DirtyFlag(){
        return this.${defield.getCodeName()?uncap_first}DirtyFlag ;
    }
    </#list>

    <#--  嵌套关系  -->
    <#if de.getMajorPSDERs()??>
    <#list de.getMajorPSDERs() as der>
    <#if der.getDERType() =='DER1N' && der.isNestedRS()>
    /**
     * ${der.getMinorPSDataEntity().getLogicName()}
     */
    private List<${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${der.getMinorPSDataEntity().getCodeName()}> ${der.getMinorCodeName()?uncap_first} = new ArrayList<${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${der.getMinorPSDataEntity().getCodeName()}>();

    /**
     * 获取 [${der.getMinorPSDataEntity().getLogicName()}]
     */
    @JsonProperty("${der.getMinorCodeName()?lower_case}")
    public List<${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${der.getMinorPSDataEntity().getCodeName()}> get${der.getMinorCodeName()?cap_first}(){
        return this.${der.getMinorCodeName()?uncap_first} ;
    }

    /**
     * 设置 [${der.getMinorPSDataEntity().getLogicName()}]
     */
    @JsonProperty("${der.getMinorCodeName()?lower_case}")
    public void set${der.getMinorCodeName()?cap_first}(List<${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${der.getMinorPSDataEntity().getCodeName()}> ${der.getMinorCodeName()?uncap_first}){
        this.${der.getMinorCodeName()?uncap_first} = ${der.getMinorCodeName()?uncap_first} ;
    }

    </#if>
    </#list>
    </#if>
</#if>
}

