<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.filter.${de.getCodeName()}SearchContext;

/**
 * 实体[${item.codeName}] 服务对象接口
 */

<#--  标准模式  -->
public interface I${item.codeName}Service{
    <#assign keyfield=item.getKeyPSDEField()>
    <#if item.getAllPSDEActions()??>
       <#list item.getAllPSDEActions() as deaction>
       <#if deaction.isEnableBackend()>
            <#if (deaction.getActionType()=='USERCUSTOM') >
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.getActionType()=='DELOGIC'>
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == 'Get'>
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?uncap_first}) ;
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "Create">
     boolean ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "Update">
     boolean ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "Remove">
     boolean ${deaction.getCodeName()?uncap_first}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?uncap_first}) ;
            <#elseif deaction.codeName == "Save">
     boolean ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "GetDraft">
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "CheckKey">
     boolean ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            <#elseif deaction.codeName == "CreateBatch">
     void ${deaction.getCodeName()?uncap_first}(List<${item.codeName}> ${item.codeName?lower_case}s, int batchSize) ;
            <#elseif deaction.codeName == "UpdateBatch">
     void ${deaction.getCodeName()?uncap_first}(List<${item.codeName}> ${item.codeName?lower_case}s, int batchSize) ;
            <#elseif deaction.codeName == "RemoveBatch">
     void ${deaction.getCodeName()?uncap_first}(Collection<? extends Serializable> idList, int batchSize) ;
            <#else>
     ${item.codeName} ${deaction.getCodeName()?uncap_first}(${item.codeName} ${item.codeName?uncap_first}) ;
            </#if>
       </#if>
       </#list>
    </#if>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    <#--
    public List<${item.codeName}> list${dedataset.getCodeName()}(${item.codeName}SearchFilter filter) {
        return i${de.codeName?lower_case}Storage.list${dedataset.getCodeName()}(filter);
    }
    -->

    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    Page<${item.codeName}> search${dedataset.getCodeName()}(${item.codeName}SearchContext context) ;
        </#list>
    </#if>

    <#if de.getMinorPSDERs()??>
    <#list de.getMinorPSDERs() as der>
    <#if der.getDERType() == 'DER1N'>
    /**
     * 根据${der.getMajorPSDataEntity().getLogicName()}查询
     */
     Page<${de.getCodeName()}> selectBy${der.getCodeName()}(${srfjavatype(der.getMajorPSDataEntity().getKeyPSDEField().stdDataType)} ${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case}) ;

    </#if>
    </#list>
    </#if>
    <#--  List<${item.codeName}> listByMapTable(Map<String, Object> map);  -->
}
